# -*- coding: utf-8 -*-
"""
Created on Thu Oct 10 15:35:30 2019

@author: ostab
"""
import matplotlib.pyplot as plt
import numpy as np
import matplotlib.colors


def TriReadOFF(nomfich):
    "Read a triangulation in an ascii .OFF file"
    ipoint = -1
    nbpoints = 0
    nbtriangles = 0
    itriangle = 0
    offfound = False
    for line in open(nomfich):
        li=line.strip() 
        if (ipoint >= nbpoints) & (itriangle < nbtriangles):  # reading triangles
            word = li.split()
            itrnoe[itriangle,:] = [ eval(word[1]), eval(word[2]), eval(word[3]) ]
            itriangle = itriangle + 1
        if ( ipoint >= 0 ) and (ipoint < nbpoints):  # read points coordinates
            word = li.split()
            XYZ[ipoint,:] = [ eval(word[0]), eval(word[1]), eval(word[2]) ]
            ipoint = ipoint + 1
        if ( ipoint == -1 ) and ( offfound ):
            word = li.split()
            nbpoints = eval(word[0])
            nbtriangles = eval(word[1])
            ipoint = 0
            XYZ = np.zeros((nbpoints,3))
            itrnoe = np.zeros((nbtriangles,3), dtype = int)
            print("nbpoints = ", nbpoints,"  nbtriangles = ", nbtriangles)
        if ( li == "OFF" ):
            offfound = True
    return [XYZ, itrnoe]        

def TriPlot2d(XYZcoord,itrnoe):
    cmap = matplotlib.colors.ListedColormap("limegreen")
    # cmap est une palette de couleur ici reduite a une couleur unique 
    # Pour afficher la triangulation :
    nbtriangles = len(itrnoe)
    triangleColor = np.ones(nbtriangles)
    print(nbtriangles)
    plt.tripcolor(XYZcoord[:,0],XYZcoord[:,1],itrnoe, triangleColor, edgecolor="k", lw=2, cmap=cmap)
    plt.show()
    return
